/* afg4d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int afg4d_c(doublereal *a, integer *m, integer *n, integer *
        nlead, doublereal *rcond, doublereal *z__, integer *ierr)
{
    /* Format strings */
    static char fmt_330[] = "";
    static char fmt_480[] = "";
    static char fmt_530[] = "";
    static char fmt_570[] = "";
    static char fmt_620[] = "";
    static char fmt_660[] = "";
    static char fmt_670[] = "";
    static char fmt_750[] = "";
    static char fmt_470[] = "";
    static char fmt_560[] = "";
    static char fmt_650[] = "";
    static char fmt_740[] = "";

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3;
    doublereal d__1, d__2, d__3, d__4, d__5, d__6;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static integer i__, j, k, l;
    static doublereal s, t, x, anorm, ynorm;
    static integer kb;
    static doublereal ek;
    static integer jj, ll;
    static doublereal sm, wk;
    extern /* Subroutine */ int utafsi_c(char *, char *, char *, char *, char *
            , integer *, ftnlen, ftnlen, ftnlen, ftnlen, ftnlen);
    static integer kp1, nm1;
    static doublereal wkm;

    /* Assigned format variables */
    static char *ll_fmt;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]

/* ************************************************** */
/*  LU-PAOEHE METOOM AYCCA C BOPOM BEYEO   */
/*  EMEHTA O CTOY  OEHKA CA OYCOBEH-    */
/*  HOCT MATP A.                                  */
/* ************************************************** */
    /* Parameter adjustments */
    a_dim1 = *m;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    --nlead;
    --z__;

    /* Function Body */
    *rcond = 0.;

/*  YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH */
    x = 0.;
/* L10: */

/*  POBEPKA PABHOCT AAH APAMETPOB M  N */
    if (*n >= 1 && *m >= 1) {
        goto L20;
    }
    *ierr = 65;
    utafsi_c("A", "F", "G", "4", "D", ierr, 1L, 1L, 1L, 1L, 1L);
    goto L760;
L20:
    *ierr = 0;

/*  BCEHE 1-HOPM MATP A */
    anorm = 0.;
    k = *n % 6;
    kp1 = k + 1;
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        t = 0.;
        if (k == 0) {
            goto L40;
        }
        i__2 = k;
        for (jj = 1; jj <= i__2; ++jj) {
            t += (d__1 = a_ref(jj, j), abs(d__1));
/* L30: */
        }
        if (*n < 6) {
            goto L60;
        }
L40:
        i__2 = *n;
        for (jj = kp1; jj <= i__2; jj += 6) {
            t = t + (d__1 = a_ref(jj, j), abs(d__1)) + (d__2 = a_ref(jj + 1, 
                    j), abs(d__2)) + (d__3 = a_ref(jj + 2, j), abs(d__3)) + (
                    d__4 = a_ref(jj + 3, j), abs(d__4)) + (d__5 = a_ref(jj + 
                    4, j), abs(d__5)) + (d__6 = a_ref(jj + 5, j), abs(d__6));
/* L50: */
        }
L60:
        if (t > anorm) {
            anorm = t;
        }
/* L70: */
    }

/*  LU-PAOEHE MATP A */
    nm1 = *n - 1;
    if (nm1 < 1) {
        goto L240;
    }
    i__1 = nm1;
    for (k = 1; k <= i__1; ++k) {
        kp1 = k + 1;

/*  HAXOEHE HEKCA BEYEO EMEHTA L */
        l = k;
        t = (d__1 = a_ref(k, k), abs(d__1));
        i__2 = *n;
        for (j = kp1; j <= i__2; ++j) {
            if ((d__1 = a_ref(j, k), abs(d__1)) <= t) {
                goto L80;
            }
            l = j;
            t = (d__1 = a_ref(j, k), abs(d__1));
L80:
/* L90: */
            ;
        }
        nlead[k] = l;
        if (a_ref(l, k) == 0.) {
            goto L210;
        }

/*  EPECTAHOBKA,EC TPEYETC */
        if (l == k) {
            goto L100;
        }
        t = a_ref(l, k);
        a_ref(l, k) = a_ref(k, k);
        a_ref(k, k) = t;
L100:

/*  BCEHE MHOTEE */
        t = -1. / a_ref(k, k);
        j = *n - k;
        i__ = j % 5 + k;
        if (i__ == k) {
            goto L120;
        }
        i__2 = i__;
        for (j = kp1; j <= i__2; ++j) {
            a_ref(j, k) = t * a_ref(j, k);
/* L110: */
        }
L120:
        ++i__;
        if (i__ > *n) {
            goto L140;
        }
        i__2 = *n;
        for (j = i__; j <= i__2; j += 5) {
            a_ref(j, k) = t * a_ref(j, k);
            a_ref(j + 1, k) = t * a_ref(j + 1, k);
            a_ref(j + 2, k) = t * a_ref(j + 2, k);
            a_ref(j + 3, k) = t * a_ref(j + 3, k);
            a_ref(j + 4, k) = t * a_ref(j + 4, k);
/* L130: */
        }
L140:

/*  AYCCOBO CKEHE */
        i__2 = *n;
        for (j = kp1; j <= i__2; ++j) {
            t = a_ref(l, j);
            if (l == k) {
                goto L150;
            }
            a_ref(l, j) = a_ref(k, j);
            a_ref(k, j) = t;
L150:
            jj = *n - k;
            i__ = jj % 4 + k;
            if (i__ == k) {
                goto L170;
            }
            i__3 = i__;
            for (jj = kp1; jj <= i__3; ++jj) {
                a_ref(jj, j) = a_ref(jj, j) + t * a_ref(jj, k);
/* L160: */
            }
L170:
            ++i__;
            if (i__ > *n) {
                goto L190;
            }
            i__3 = *n;
            for (jj = i__; jj <= i__3; jj += 4) {
                a_ref(jj, j) = a_ref(jj, j) + t * a_ref(jj, k);
                a_ref(jj + 1, j) = a_ref(jj + 1, j) + t * a_ref(jj + 1, k);
                a_ref(jj + 2, j) = a_ref(jj + 2, j) + t * a_ref(jj + 2, k);
                a_ref(jj + 3, j) = a_ref(jj + 3, j) + t * a_ref(jj + 3, k);
/* L180: */
            }
L190:
/* L200: */
            ;
        }
        goto L220;
L210:
        *ierr = -k;
L220:
/* L230: */
        ;
    }
L240:
    if (a_ref(*n, *n) == 0.) {
        *ierr = -(*n);
    }
    nlead[*n] = *n;
    if (*ierr == 0) {
        goto L250;
    }
    utafsi_c("A", "F", "G", "4", "D", ierr, 1L, 1L, 1L, 1L, 1L);
    goto L760;
L250:

/* BCEHE RCOND-BEH,OPATHO CY OYCOBEHHOCT MATP A.*/
/*  BCEH HOPM MATP INVERSE(A) PEAETC CCTEMA A*Z=Y,    */
/* E Y-PEEHE CCTEM TRANS(A)*Y=E;KOMOHEHT BEKTOPA E BPATC  */
/* TAKM OPAOM,TO MAKCMPOBAT HOPMY BEKTOPA W,E W-PEEHE  */
/* CCTEM TRANS(U)*W=E. */

/*  PEEHE CCTEM TRANS(U)*W=E OHOBPEMEHHO C BOPOM E */
    ek = 1.;
    if (*n >= 2) {
        goto L260;
    }
    *rcond = 1.;
    goto L760;
L260:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
        z__[j] = 0.;
/* L270: */
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        if (z__[k] != 0.) {
            d__1 = -z__[k];
            ek = d_sign(&ek, &d__1);
        }
        if ((d__1 = ek - z__[k], abs(d__1)) <= (d__2 = a_ref(k, k), abs(d__2))
                ) {
            goto L340;
        }
        s = (d__1 = a_ref(k, k), abs(d__1)) / (d__2 = ek - z__[k], abs(d__2));
        ll = 0;
        ll_fmt = fmt_330;
L280:
        i__ = *n % 5;
        if (i__ == 0) {
            goto L300;
        }
        i__2 = i__;
        for (jj = 1; jj <= i__2; ++jj) {
            z__[jj] = s * z__[jj];
/* L290: */
        }
        if (*n < 5) {
            goto L320;
        }
L300:
        ++i__;
        i__2 = *n;
        for (jj = i__; jj <= i__2; jj += 5) {
            z__[jj] = s * z__[jj];
            z__[jj + 1] = s * z__[jj + 1];
            z__[jj + 2] = s * z__[jj + 2];
            z__[jj + 3] = s * z__[jj + 3];
            z__[jj + 4] = s * z__[jj + 4];
/* L310: */
        }
L320:
        switch (ll) {
            case 0: goto L330;
            case 1: goto L470;
            case 2: goto L480;
            case 3: goto L530;
            case 4: goto L560;
            case 5: goto L570;
            case 6: goto L620;
            case 7: goto L650;
            case 8: goto L660;
            case 9: goto L670;
            case 10: goto L740;
            case 11: goto L750;
        }
L330:
        ek = s * ek;
L340:
        wk = ek - z__[k];
        wkm = -ek - z__[k];
        s = abs(wk);
        sm = abs(wkm);
        if (a_ref(k, k) == 0.) {
            goto L350;
        }
        wk /= a_ref(k, k);
        wkm /= a_ref(k, k);
        goto L360;
L350:
        wk = 1.;
        wkm = 1.;
L360:
        kp1 = k + 1;
        if (kp1 > *n) {
            goto L400;
        }
        i__2 = *n;
        for (j = kp1; j <= i__2; ++j) {
            sm += (d__1 = z__[j] + wkm * a_ref(k, j), abs(d__1));
            z__[j] += wk * a_ref(k, j);
            s += (d__1 = z__[j], abs(d__1));
/* L370: */
        }
        if (s >= sm) {
            goto L390;
        }
        t = wkm - wk;
        wk = wkm;
        i__2 = *n;
        for (j = kp1; j <= i__2; ++j) {
            z__[j] += t * a_ref(k, j);
/* L380: */
        }
L390:
L400:
        z__[k] = wk;
/* L410: */
    }
    ll = 1;
    ll_fmt = fmt_470;
L420:
    s = 0.;
    i__ = *n % 6;
    if (i__ == 0) {
        goto L440;
    }
    i__1 = i__;
    for (jj = 1; jj <= i__1; ++jj) {
        s += (d__1 = z__[jj], abs(d__1));
/* L430: */
    }
    if (*n < 6) {
        goto L460;
    }
L440:
    ++i__;
    i__1 = *n;
    for (jj = i__; jj <= i__1; jj += 6) {
        s = s + (d__1 = z__[jj], abs(d__1)) + (d__2 = z__[jj + 1], abs(d__2)) 
                + (d__3 = z__[jj + 2], abs(d__3)) + (d__4 = z__[jj + 3], abs(
                d__4)) + (d__5 = z__[jj + 4], abs(d__5)) + (d__6 = z__[jj + 5]
                , abs(d__6));
/* L450: */
    }
L460:
    s = 1. / s;
    switch (ll) {
        case 0: goto L330;
        case 1: goto L470;
        case 2: goto L480;
        case 3: goto L530;
        case 4: goto L560;
        case 5: goto L570;
        case 6: goto L620;
        case 7: goto L650;
        case 8: goto L660;
        case 9: goto L670;
        case 10: goto L740;
        case 11: goto L750;
    }
L470:
    ll = 2;
    ll_fmt = fmt_480;
    goto L280;
L480:

/*  PEEHE CCTEM TRANS(L)*Y=W */
    i__1 = *n;
    for (kb = 1; kb <= i__1; ++kb) {
        k = *n + 1 - kb;
        if (k >= *n) {
            goto L520;
        }
        kp1 = k + 1;
        jj = *n - k;
        i__ = jj % 5 + k;
        if (i__ == k) {
            goto L500;
        }
        i__2 = i__;
        for (jj = kp1; jj <= i__2; ++jj) {
            z__[k] += a_ref(jj, k) * z__[jj];
/* L490: */
        }
L500:
        ++i__;
        if (i__ > *n) {
            goto L520;
        }
        i__2 = *n;
        for (jj = i__; jj <= i__2; jj += 5) {
            z__[k] = z__[k] + a_ref(jj, k) * z__[jj] + a_ref(jj + 1, k) * z__[
                    jj + 1] + a_ref(jj + 2, k) * z__[jj + 2] + a_ref(jj + 3, 
                    k) * z__[jj + 3] + a_ref(jj + 4, k) * z__[jj + 4];
/* L510: */
        }
L520:
        if ((d__1 = z__[k], abs(d__1)) <= 1.) {
            goto L540;
        }
        s = 1. / (d__1 = z__[k], abs(d__1));
        ll = 3;
        ll_fmt = fmt_530;
        goto L280;
L530:
L540:
        l = nlead[k];
        t = z__[l];
        z__[l] = z__[k];
        z__[k] = t;
/* L550: */
    }
    ll = 4;
    ll_fmt = fmt_560;
    goto L420;
L560:
    ll = 5;
    ll_fmt = fmt_570;
    goto L280;
L570:
    ynorm = 1.;

/*  PEEHE CCTEM L*V=Y  BCEHE HOPM BEKTOPA Y */
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
        l = nlead[k];
        t = z__[l];
        z__[l] = z__[k];
        z__[k] = t;
        if (k >= *n) {
            goto L610;
        }
        kp1 = k + 1;
        jj = *n - k;
        i__ = jj % 4 + k;
        if (i__ == k) {
            goto L590;
        }
        i__2 = i__;
        for (jj = kp1; jj <= i__2; ++jj) {
            z__[jj] += t * a_ref(jj, k);
/* L580: */
        }
L590:
        ++i__;
        if (i__ > *n) {
            goto L610;
        }
        i__2 = *n;
        for (jj = i__; jj <= i__2; jj += 4) {
            z__[jj] += t * a_ref(jj, k);
            z__[jj + 1] += t * a_ref(jj + 1, k);
            z__[jj + 2] += t * a_ref(jj + 2, k);
            z__[jj + 3] += t * a_ref(jj + 3, k);
/* L600: */
        }
L610:
        if ((d__1 = z__[k], abs(d__1)) <= 1.) {
            goto L630;
        }
        s = 1. / (d__1 = z__[k], abs(d__1));
        ll = 6;
        ll_fmt = fmt_620;
        goto L280;
L620:
        ynorm = s * ynorm;
L630:
/* L640: */
        ;
    }
    ll = 7;
    ll_fmt = fmt_650;
    goto L420;
L650:
    ll = 8;
    ll_fmt = fmt_660;
    goto L280;
L660:
    ynorm = s * ynorm;

/*  PEEHE CCTEM U*Z=V */
    i__1 = *n;
    for (kb = 1; kb <= i__1; ++kb) {
        k = *n + 1 - kb;
        if ((d__1 = z__[k], abs(d__1)) <= (d__2 = a_ref(k, k), abs(d__2))) {
            goto L680;
        }
        s = (d__1 = a_ref(k, k), abs(d__1)) / (d__2 = z__[k], abs(d__2));
        ll = 9;
        ll_fmt = fmt_670;
        goto L280;
L670:
        ynorm = s * ynorm;
L680:
        if (a_ref(k, k) != 0.) {
            z__[k] /= a_ref(k, k);
        }
        if (a_ref(k, k) == 0.) {
            z__[k] = 1.;
        }
        t = -z__[k];
        l = k - 1;
        if (l < 1) {
            goto L720;
        }
        i__ = l % 4;
        if (i__ == 0) {
            goto L700;
        }
        i__2 = i__;
        for (jj = 1; jj <= i__2; ++jj) {
            z__[jj] += t * a_ref(jj, k);
/* L690: */
        }
L700:
        ++i__;
        if (i__ > l) {
            goto L720;
        }
        i__2 = l;
        for (jj = i__; jj <= i__2; jj += 4) {
            z__[jj] += t * a_ref(jj, k);
            z__[jj + 1] += t * a_ref(jj + 1, k);
            z__[jj + 2] += t * a_ref(jj + 2, k);
            z__[jj + 3] += t * a_ref(jj + 3, k);
/* L710: */
        }
L720:
/* L730: */
        ;
    }
    ll = 10;
    ll_fmt = fmt_740;
    goto L420;
L740:
    ll = 11;
    ll_fmt = fmt_750;
    goto L280;
L750:
    ynorm = s * ynorm;
    if (anorm != 0.) {
        *rcond = ynorm / anorm;
    }
L760:
    return 0;
} /* afg4d_c */

#undef a_ref
